/**
 * 
 */
package weka.classifiers.timeseries.eval;

import java.util.List;

import weka.classifiers.evaluation.NumericPrediction;
import weka.core.Utils;

/**
 * @author mhall
 *
 */
public class MSEModule extends ErrorModule {

  public String getEvalName() {
    return "MSE";
  }
  
  public String getDescription() {
    return "Mean squared error";
  }
  
  public String getDefinition() {
    return "sum((predicted - actual)^2) / N";
  }
  
  public double[] calculateMeasure() throws Exception {
   double[] result = new double[m_targetFieldNames.size()];
   for (int i = 0; i < result.length; i++) {
     result[i] = Utils.missingValue();
   }
    
    for (int i = 0; i < m_targetFieldNames.size(); i++) {
      double sumSq = 0;
      List<NumericPrediction> preds = m_predictions.get(i);

      int count = 0;
      for (NumericPrediction p : preds) {
        if (!Utils.isMissingValue(p.error())) {
          sumSq += (p.error() * p.error());
          count++;
        }
      }
      
      if (m_counts[i] > 0) {
        sumSq /= m_counts[i];
      }
      
      if (count > 0) {
        result[i] = sumSq;
      } else {
        result[i] = Utils.missingValue();
      }
    }
    
    return result;
  }
  
}
