/**
 * 
 */
package weka.classifiers.timeseries.eval;

import weka.core.Utils;

/**
 * @author mhall
 *
 */
public class RMSEModule extends MSEModule {
  public String getEvalName() {
    return "RMSE";
  }
  
  public String getDescription() {
    return "Root mean squared error";
  }
  
  public String getDefinition() {
    return "sqrt(sum((predicted - actual)^2) / N)";
  }
  
  public double[] calculateMeasure() throws Exception {
    double[] result = super.calculateMeasure();
    
    for (int i = 0; i < result.length; i++) {
      if (!Utils.isMissingValue(result[i])) {
        result[i] = Math.sqrt(result[i]);
      }
    }
    
    return result;
  }
}
